<?php

	function clientEventHandler($client_key, $client_data)
	{
		$localizationDirectory = "localization";

		switch ($client_key)
		{
			//  
			case "LoadConfiguration":
				echo getConfigFile("config.xml", $localizationDirectory);
				break;


			//       
			//   - .mrt  ( .mdc   )
			//  $client_data     ,     
			//    ,    'null'
 			case "LoadReport":
				if ($client_data != "null") $result = getReportByKey($client_data);
				echo $result;
				break;


			//     URL
			//   ,     
			case "LoadReportFile":
				echo file_get_contents($client_data);
				break;


			//    
			case "LoadLanguage":
				echo file_get_contents($localizationDirectory."/".$client_data);
				break;


			//  
			case "SaveReport":
				//  $client_data   .mrt 
				//   -  
				//  :
				//     -1:     
				//     0:   "  "
				//        

				echo "-1";
				break;


			//   
			case "RetrieveColumns":
				$connectionType = getXmlKeyValue($client_data, "ConnectionType");
				$connectionString = getXmlKeyValue($client_data, "ConnectionString");
				$query = getXmlKeyValue($client_data, "Query");

				switch ($connectionType)
				{
					case "StiSqlDatabase":
						$object = parseSqlConnectionString($connectionString);
						$xml = getSqlDatabaseColumns($object->host, $object->database, $object->userId, $object->password, $query);
						break;

					case "StiMySqlDatabase":
						$object = parseMySqlConnectionString($connectionString);
						$xml = getMySqlDatabaseColumns($object->host, $object->port, $object->database, $object->userId, $object->password, $query);
						break;
						
					case "StiOdbcDatabase":
						$object = parseOdbcConnectionString($connectionString);
						$xml = getOdbcDatabaseColumns($object->dsn, $object->userId, $object->password, $query);
						break;
				}

				echo $xml;
				break;


			//  
			//   -    xml
			case "LoadData":
				$connectionType = getXmlKeyValue($client_data, "ConnectionType");
				$connectionString = getXmlKeyValue($client_data, "ConnectionString");
				$query = getXmlKeyValue($client_data, "Query");

				switch ($connectionType)
				{
					case "StiSqlDatabase":
						$object = parseSqlConnectionString($connectionString);
						$xml = getDataFromSqlDatabase($object->host, $object->database, $object->userId, $object->password, $query);
						break;

					case "StiMySqlDatabase":
						$object = parseMySqlConnectionString($connectionString);
						$xml = getDataFromMySqlDatabase($object->host, $object->port, $object->database, $object->userId, $object->password, $query);
						break;
						
					case "StiOdbcDatabase":
						$object = parseOdbcConnectionString($connectionString);
						$xml = getDataFromOdbcDatabase($object->dsn, $object->userId, $object->password, $query);
						break;
				}

				echo $xml;
				break;
		}
	}


	//  .mrt  .mdc    ,     
	//            
	function getReportByKey($report_key)
	{
		switch ($report_key)
		{
			case "1": return file_get_contents("../samples/SimpleList.mrt");
			case "2": return file_get_contents("../samples/SimpleList.mdc");
		}
	}
?>