<?php

	//    
	function getLocalizationsList($localizationDirectory)
	{
		$list = array();

		if (is_dir($localizationDirectory))
		{
			$directory = opendir($localizationDirectory);
			$index = 0;

			while ($fileName = readdir($directory))
			{
				$parts = explode(".", $fileName);
				if (is_array($parts) && count($parts) > 1)
				{
					$extension = end($parts);
					if (strtolower($extension) == "xml") $list[$index++] = $parts[0];
				}
			}

			closedir($directory);
		}

		return $list;
	}

	//     ,     -  
	function getLocalizationsListNode($configXml)
	{
		$configNode = $configXml->getElementsByTagName("Configuration")->item(0);

		$localizationsNode = $configNode->getElementsByTagName("Localizations")->item(0);
		if (!isset($localizationsNode))
		{
			$localizationsNode = $configXml->createElement("Localizations");
			$configNode->appendChild($localizationsNode);
		}

		$localizationsListNode = $localizationsNode->getElementsByTagName("LocalizationsList")->item(0);
		if (!isset($localizationsListNode))
		{
			$localizationsListNode = $configXml->createElement("LocalizationsList");
			$localizationsNode->appendChild($localizationsListNode);
		}

		return $localizationsListNode;
	}

	//     
	function getLocalizationNode($configXml, $localizationDirectory, $localizationFileName)
	{
		$localizationXml = new DOMDocument();
		$localizationXml->load($localizationDirectory."/".$localizationFileName.".xml");
		$localizationNode = $localizationXml->getElementsByTagName("Localization")->item(0);

		$element = $configXml->createElement("Value");

		$value = $configXml->createElement("FileName", $localizationFileName.".xml");
		$element->appendChild($value);

		$value = $configXml->createElement("Language", $localizationNode->getAttribute("language"));
		$element->appendChild($value);

		$value = $configXml->createElement("Description", $localizationNode->getAttribute("description"));
		$element->appendChild($value);

		$value = $configXml->createElement("CultureName", $localizationNode->getAttribute("cultureName"));
		$element->appendChild($value);

		return $element;
	}

	//  config.xml       
	function getConfigFile($configFileName, $localizationDirectory)
	{
		$configXml = new DOMDocument();
		$configXml->preserveWhiteSpace = false;
		$configXml->formatOutput = true;
		$configXml->load($configFileName);

		$localizationsList = getLocalizationsList($localizationDirectory);
		$localizationsListNode = getLocalizationsListNode($configXml);
		foreach ($localizationsList as $localizationFileName)
		{
			$element = getLocalizationNode($configXml, $localizationDirectory, $localizationFileName);
			$localizationsListNode->appendChild($element);
		}

		return $configXml->saveXML();
	}
?>
